use crate::impl_extensions;

impl_extensions! {
    DeviceExtensions,
    doc = "Device extensions.",
    (VK_KHR_swapchain, khr_swapchain),
    (VK_KHR_display_swapchain, khr_display_swapchain),
    (VK_NV_glsl_shader, nv_glsl_shader),
    (VK_EXT_depth_range_unrestricted, ext_depth_range_unrestricted),
    (VK_KHR_sampler_mirror_clamp_to_edge, khr_sampler_mirror_clamp_to_edge),
    (VK_IMG_filter_cubic, img_filter_cubic),
    (VK_AMD_rasterization_order, amd_rasterization_order),
    (VK_AMD_shader_trinary_minmax, amd_shader_trinary_minmax),
    (VK_AMD_shader_explicit_vertex_parameter, amd_shader_explicit_vertex_parameter),
    (VK_EXT_debug_marker, ext_debug_marker),
    (VK_KHR_video_queue, khr_video_queue),
    (VK_KHR_video_decode_queue, khr_video_decode_queue),
    (VK_AMD_gcn_shader, amd_gcn_shader),
    (VK_NV_dedicated_allocation, nv_dedicated_allocation),
    (VK_EXT_transform_feedback, ext_transform_feedback),
    (VK_NVX_binary_import, nvx_binary_import),
    (VK_NVX_image_view_handle, nvx_image_view_handle),
    (VK_AMD_draw_indirect_count, amd_draw_indirect_count),
    (VK_AMD_negative_viewport_height, amd_negative_viewport_height),
    (VK_AMD_gpu_shader_half_float, amd_gpu_shader_half_float),
    (VK_AMD_shader_ballot, amd_shader_ballot),
    (VK_EXT_video_encode_h264, ext_video_encode_h264),
    (VK_EXT_video_encode_h265, ext_video_encode_h265),
    (VK_EXT_video_decode_h264, ext_video_decode_h264),
    (VK_AMD_texture_gather_bias_lod, amd_texture_gather_bias_lod),
    (VK_AMD_shader_info, amd_shader_info),
    (VK_KHR_dynamic_rendering, khr_dynamic_rendering),
    (VK_AMD_shader_image_load_store_lod, amd_shader_image_load_store_lod),
    (VK_NV_corner_sampled_image, nv_corner_sampled_image),
    (VK_KHR_multiview, khr_multiview),
    (VK_IMG_format_pvrtc, img_format_pvrtc),
    (VK_NV_external_memory, nv_external_memory),
    (VK_NV_external_memory_win32, nv_external_memory_win32),
    (VK_NV_win32_keyed_mutex, nv_win32_keyed_mutex),
    (VK_KHR_device_group, khr_device_group),
    (VK_KHR_shader_draw_parameters, khr_shader_draw_parameters),
    (VK_EXT_shader_subgroup_ballot, ext_shader_subgroup_ballot),
    (VK_EXT_shader_subgroup_vote, ext_shader_subgroup_vote),
    (VK_EXT_texture_compression_astc_hdr, ext_texture_compression_astc_hdr),
    (VK_EXT_astc_decode_mode, ext_astc_decode_mode),
    (VK_KHR_maintenance1, khr_maintenance1),
    (VK_KHR_external_memory, khr_external_memory),
    (VK_KHR_external_memory_win32, khr_external_memory_win32),
    (VK_KHR_external_memory_fd, khr_external_memory_fd),
    (VK_KHR_win32_keyed_mutex, khr_win32_keyed_mutex),
    (VK_KHR_external_semaphore, khr_external_semaphore),
    (VK_KHR_external_semaphore_win32, khr_external_semaphore_win32),
    (VK_KHR_external_semaphore_fd, khr_external_semaphore_fd),
    (VK_KHR_push_descriptor, khr_push_descriptor),
    (VK_EXT_conditional_rendering, ext_conditional_rendering),
    (VK_KHR_shader_float16_int8, khr_shader_float16_int8),
    (VK_KHR_16bit_storage, khr_16bit_storage),
    (VK_KHR_incremental_present, khr_incremental_present),
    (VK_KHR_descriptor_update_template, khr_descriptor_update_template),
    (VK_NV_clip_space_w_scaling, nv_clip_space_w_scaling),
    (VK_EXT_display_control, ext_display_control),
    (VK_GOOGLE_display_timing, google_display_timing),
    (VK_NV_sample_mask_override_coverage, nv_sample_mask_override_coverage),
    (VK_NV_geometry_shader_passthrough, nv_geometry_shader_passthrough),
    (VK_NV_viewport_array2, nv_viewport_array2),
    (VK_NVX_multiview_per_view_attributes, nvx_multiview_per_view_attributes),
    (VK_NV_viewport_swizzle, nv_viewport_swizzle),
    (VK_EXT_discard_rectangles, ext_discard_rectangles),
    (VK_EXT_conservative_rasterization, ext_conservative_rasterization),
    (VK_EXT_depth_clip_enable, ext_depth_clip_enable),
    (VK_EXT_hdr_metadata, ext_hdr_metadata),
    (VK_KHR_imageless_framebuffer, khr_imageless_framebuffer),
    (VK_KHR_create_renderpass2, khr_create_renderpass2),
    (VK_KHR_shared_presentable_image, khr_shared_presentable_image),
    (VK_KHR_external_fence, khr_external_fence),
    (VK_KHR_external_fence_win32, khr_external_fence_win32),
    (VK_KHR_external_fence_fd, khr_external_fence_fd),
    (VK_KHR_performance_query, khr_performance_query),
    (VK_KHR_maintenance2, khr_maintenance2),
    (VK_KHR_variable_pointers, khr_variable_pointers),
    (VK_EXT_external_memory_dma_buf, ext_external_memory_dma_buf),
    (VK_EXT_queue_family_foreign, ext_queue_family_foreign),
    (VK_KHR_dedicated_allocation, khr_dedicated_allocation),
    (VK_ANDROID_external_memory_android_hardware_buffer, android_external_memory_android_hardware_buffer),
    (VK_EXT_sampler_filter_minmax, ext_sampler_filter_minmax),
    (VK_KHR_storage_buffer_storage_class, khr_storage_buffer_storage_class),
    (VK_AMD_gpu_shader_int16, amd_gpu_shader_int16),
    (VK_AMD_mixed_attachment_samples, amd_mixed_attachment_samples),
    (VK_AMD_shader_fragment_mask, amd_shader_fragment_mask),
    (VK_EXT_inline_uniform_block, ext_inline_uniform_block),
    (VK_EXT_shader_stencil_export, ext_shader_stencil_export),
    (VK_EXT_sample_locations, ext_sample_locations),
    (VK_KHR_relaxed_block_layout, khr_relaxed_block_layout),
    (VK_KHR_get_memory_requirements2, khr_get_memory_requirements2),
    (VK_KHR_image_format_list, khr_image_format_list),
    (VK_EXT_blend_operation_advanced, ext_blend_operation_advanced),
    (VK_NV_fragment_coverage_to_color, nv_fragment_coverage_to_color),
    (VK_KHR_acceleration_structure, khr_acceleration_structure),
    (VK_KHR_ray_tracing_pipeline, khr_ray_tracing_pipeline),
    (VK_KHR_ray_query, khr_ray_query),
    (VK_NV_framebuffer_mixed_samples, nv_framebuffer_mixed_samples),
    (VK_NV_fill_rectangle, nv_fill_rectangle),
    (VK_NV_shader_sm_builtins, nv_shader_sm_builtins),
    (VK_EXT_post_depth_coverage, ext_post_depth_coverage),
    (VK_KHR_sampler_ycbcr_conversion, khr_sampler_ycbcr_conversion),
    (VK_KHR_bind_memory2, khr_bind_memory2),
    (VK_EXT_image_drm_format_modifier, ext_image_drm_format_modifier),
    (VK_EXT_validation_cache, ext_validation_cache),
    (VK_EXT_descriptor_indexing, ext_descriptor_indexing),
    (VK_EXT_shader_viewport_index_layer, ext_shader_viewport_index_layer),
    (VK_KHR_portability_subset, khr_portability_subset),
    (VK_NV_shading_rate_image, nv_shading_rate_image),
    (VK_NV_ray_tracing, nv_ray_tracing),
    (VK_NV_representative_fragment_test, nv_representative_fragment_test),
    (VK_KHR_maintenance3, khr_maintenance3),
    (VK_KHR_draw_indirect_count, khr_draw_indirect_count),
    (VK_EXT_filter_cubic, ext_filter_cubic),
    (VK_QCOM_render_pass_shader_resolve, qcom_render_pass_shader_resolve),
    (VK_EXT_global_priority, ext_global_priority),
    (VK_KHR_shader_subgroup_extended_types, khr_shader_subgroup_extended_types),
    (VK_KHR_8bit_storage, khr_8bit_storage),
    (VK_EXT_external_memory_host, ext_external_memory_host),
    (VK_AMD_buffer_marker, amd_buffer_marker),
    (VK_KHR_shader_atomic_int64, khr_shader_atomic_int64),
    (VK_KHR_shader_clock, khr_shader_clock),
    (VK_AMD_pipeline_compiler_control, amd_pipeline_compiler_control),
    (VK_EXT_calibrated_timestamps, ext_calibrated_timestamps),
    (VK_AMD_shader_core_properties, amd_shader_core_properties),
    (VK_EXT_video_decode_h265, ext_video_decode_h265),
    (VK_KHR_global_priority, khr_global_priority),
    (VK_AMD_memory_overallocation_behavior, amd_memory_overallocation_behavior),
    (VK_EXT_vertex_attribute_divisor, ext_vertex_attribute_divisor),
    (VK_GGP_frame_token, ggp_frame_token),
    (VK_EXT_pipeline_creation_feedback, ext_pipeline_creation_feedback),
    (VK_KHR_driver_properties, khr_driver_properties),
    (VK_KHR_shader_float_controls, khr_shader_float_controls),
    (VK_NV_shader_subgroup_partitioned, nv_shader_subgroup_partitioned),
    (VK_KHR_depth_stencil_resolve, khr_depth_stencil_resolve),
    (VK_KHR_swapchain_mutable_format, khr_swapchain_mutable_format),
    (VK_NV_compute_shader_derivatives, nv_compute_shader_derivatives),
    (VK_NV_mesh_shader, nv_mesh_shader),
    (VK_NV_fragment_shader_barycentric, nv_fragment_shader_barycentric),
    (VK_NV_shader_image_footprint, nv_shader_image_footprint),
    (VK_NV_scissor_exclusive, nv_scissor_exclusive),
    (VK_NV_device_diagnostic_checkpoints, nv_device_diagnostic_checkpoints),
    (VK_KHR_timeline_semaphore, khr_timeline_semaphore),
    (VK_INTEL_shader_integer_functions2, intel_shader_integer_functions2),
    (VK_INTEL_performance_query, intel_performance_query),
    (VK_KHR_vulkan_memory_model, khr_vulkan_memory_model),
    (VK_EXT_pci_bus_info, ext_pci_bus_info),
    (VK_AMD_display_native_hdr, amd_display_native_hdr),
    (VK_KHR_shader_terminate_invocation, khr_shader_terminate_invocation),
    (VK_EXT_fragment_density_map, ext_fragment_density_map),
    (VK_EXT_scalar_block_layout, ext_scalar_block_layout),
    (VK_GOOGLE_hlsl_functionality1, google_hlsl_functionality1),
    (VK_GOOGLE_decorate_string, google_decorate_string),
    (VK_EXT_subgroup_size_control, ext_subgroup_size_control),
    (VK_KHR_fragment_shading_rate, khr_fragment_shading_rate),
    (VK_AMD_shader_core_properties2, amd_shader_core_properties2),
    (VK_AMD_device_coherent_memory, amd_device_coherent_memory),
    (VK_EXT_shader_image_atomic_int64, ext_shader_image_atomic_int64),
    (VK_KHR_spirv_1_4, khr_spirv_1_4),
    (VK_EXT_memory_budget, ext_memory_budget),
    (VK_EXT_memory_priority, ext_memory_priority),
    (VK_NV_dedicated_allocation_image_aliasing, nv_dedicated_allocation_image_aliasing),
    (VK_KHR_separate_depth_stencil_layouts, khr_separate_depth_stencil_layouts),
    (VK_EXT_buffer_device_address, ext_buffer_device_address),
    (VK_EXT_tooling_info, ext_tooling_info),
    (VK_EXT_separate_stencil_usage, ext_separate_stencil_usage),
    (VK_KHR_present_wait, khr_present_wait),
    (VK_NV_cooperative_matrix, nv_cooperative_matrix),
    (VK_NV_coverage_reduction_mode, nv_coverage_reduction_mode),
    (VK_EXT_fragment_shader_interlock, ext_fragment_shader_interlock),
    (VK_EXT_ycbcr_image_arrays, ext_ycbcr_image_arrays),
    (VK_KHR_uniform_buffer_standard_layout, khr_uniform_buffer_standard_layout),
    (VK_EXT_provoking_vertex, ext_provoking_vertex),
    (VK_EXT_full_screen_exclusive, ext_full_screen_exclusive),
    (VK_KHR_buffer_device_address, khr_buffer_device_address),
    (VK_EXT_line_rasterization, ext_line_rasterization),
    (VK_EXT_shader_atomic_float, ext_shader_atomic_float),
    (VK_EXT_host_query_reset, ext_host_query_reset),
    (VK_EXT_index_type_uint8, ext_index_type_uint8),
    (VK_EXT_extended_dynamic_state, ext_extended_dynamic_state),
    (VK_KHR_deferred_host_operations, khr_deferred_host_operations),
    (VK_KHR_pipeline_executable_properties, khr_pipeline_executable_properties),
    (VK_EXT_shader_atomic_float2, ext_shader_atomic_float2),
    (VK_EXT_shader_demote_to_helper_invocation, ext_shader_demote_to_helper_invocation),
    (VK_NV_device_generated_commands, nv_device_generated_commands),
    (VK_NV_inherited_viewport_scissor, nv_inherited_viewport_scissor),
    (VK_KHR_shader_integer_dot_product, khr_shader_integer_dot_product),
    (VK_EXT_texel_buffer_alignment, ext_texel_buffer_alignment),
    (VK_QCOM_render_pass_transform, qcom_render_pass_transform),
    (VK_EXT_device_memory_report, ext_device_memory_report),
    (VK_EXT_robustness2, ext_robustness2),
    (VK_EXT_custom_border_color, ext_custom_border_color),
    (VK_GOOGLE_user_type, google_user_type),
    (VK_KHR_pipeline_library, khr_pipeline_library),
    (VK_KHR_shader_non_semantic_info, khr_shader_non_semantic_info),
    (VK_KHR_present_id, khr_present_id),
    (VK_EXT_private_data, ext_private_data),
    (VK_EXT_pipeline_creation_cache_control, ext_pipeline_creation_cache_control),
    (VK_KHR_video_encode_queue, khr_video_encode_queue),
    (VK_NV_device_diagnostics_config, nv_device_diagnostics_config),
    (VK_QCOM_render_pass_store_ops, qcom_render_pass_store_ops),
    (VK_KHR_synchronization2, khr_synchronization2),
    (VK_KHR_shader_subgroup_uniform_control_flow, khr_shader_subgroup_uniform_control_flow),
    (VK_KHR_zero_initialize_workgroup_memory, khr_zero_initialize_workgroup_memory),
    (VK_NV_fragment_shading_rate_enums, nv_fragment_shading_rate_enums),
    (VK_NV_ray_tracing_motion_blur, nv_ray_tracing_motion_blur),
    (VK_EXT_ycbcr_2plane_444_formats, ext_ycbcr_2plane_444_formats),
    (VK_EXT_fragment_density_map2, ext_fragment_density_map2),
    (VK_QCOM_rotated_copy_commands, qcom_rotated_copy_commands),
    (VK_EXT_image_robustness, ext_image_robustness),
    (VK_KHR_workgroup_memory_explicit_layout, khr_workgroup_memory_explicit_layout),
    (VK_KHR_copy_commands2, khr_copy_commands2),
    (VK_EXT_4444_formats, ext_4444_formats),
    (VK_ARM_rasterization_order_attachment_access, arm_rasterization_order_attachment_access),
    (VK_EXT_rgba10x6_formats, ext_rgba10x6_formats),
    (VK_NV_acquire_winrt_display, nv_acquire_winrt_display),
    (VK_VALVE_mutable_descriptor_type, valve_mutable_descriptor_type),
    (VK_EXT_vertex_input_dynamic_state, ext_vertex_input_dynamic_state),
    (VK_EXT_physical_device_drm, ext_physical_device_drm),
    (VK_EXT_depth_clip_control, ext_depth_clip_control),
    (VK_EXT_primitive_topology_list_restart, ext_primitive_topology_list_restart),
    (VK_KHR_format_feature_flags2, khr_format_feature_flags2),
    (VK_FUCHSIA_external_memory, fuchsia_external_memory),
    (VK_FUCHSIA_external_semaphore, fuchsia_external_semaphore),
    (VK_FUCHSIA_buffer_collection, fuchsia_buffer_collection),
    (VK_HUAWEI_subpass_shading, huawei_subpass_shading),
    (VK_HUAWEI_invocation_mask, huawei_invocation_mask),
    (VK_NV_external_memory_rdma, nv_external_memory_rdma),
    (VK_EXT_extended_dynamic_state2, ext_extended_dynamic_state2),
    (VK_EXT_color_write_enable, ext_color_write_enable),
    (VK_EXT_global_priority_query, ext_global_priority_query),
    (VK_EXT_image_view_min_lod, ext_image_view_min_lod),
    (VK_EXT_multi_draw, ext_multi_draw),
    (VK_EXT_load_store_op_none, ext_load_store_op_none),
    (VK_EXT_border_color_swizzle, ext_border_color_swizzle),
    (VK_EXT_pageable_device_local_memory, ext_pageable_device_local_memory),
    (VK_KHR_maintenance4, khr_maintenance4),
    (VK_QCOM_fragment_density_map_offset, qcom_fragment_density_map_offset),
    (VK_NV_linear_color_attachment, nv_linear_color_attachment)
}

#[cfg(test)]
mod tests {
    use crate::gfx::physical_device::DeviceExtensions;

    #[test]
    fn default() {
        assert_eq!(
            DeviceExtensions {
                khr_swapchain: false,
                khr_display_swapchain: false,
                nv_glsl_shader: false,
                ext_depth_range_unrestricted: false,
                khr_sampler_mirror_clamp_to_edge: false,
                img_filter_cubic: false,
                amd_rasterization_order: false,
                amd_shader_trinary_minmax: false,
                amd_shader_explicit_vertex_parameter: false,
                ext_debug_marker: false,
                khr_video_queue: false,
                khr_video_decode_queue: false,
                amd_gcn_shader: false,
                nv_dedicated_allocation: false,
                ext_transform_feedback: false,
                nvx_binary_import: false,
                nvx_image_view_handle: false,
                amd_draw_indirect_count: false,
                amd_negative_viewport_height: false,
                amd_gpu_shader_half_float: false,
                amd_shader_ballot: false,
                ext_video_encode_h264: false,
                ext_video_encode_h265: false,
                ext_video_decode_h264: false,
                amd_texture_gather_bias_lod: false,
                amd_shader_info: false,
                khr_dynamic_rendering: false,
                amd_shader_image_load_store_lod: false,
                nv_corner_sampled_image: false,
                khr_multiview: false,
                img_format_pvrtc: false,
                nv_external_memory: false,
                nv_external_memory_win32: false,
                nv_win32_keyed_mutex: false,
                khr_device_group: false,
                khr_shader_draw_parameters: false,
                ext_shader_subgroup_ballot: false,
                ext_shader_subgroup_vote: false,
                ext_texture_compression_astc_hdr: false,
                ext_astc_decode_mode: false,
                khr_maintenance1: false,
                khr_external_memory: false,
                khr_external_memory_win32: false,
                khr_external_memory_fd: false,
                khr_win32_keyed_mutex: false,
                khr_external_semaphore: false,
                khr_external_semaphore_win32: false,
                khr_external_semaphore_fd: false,
                khr_push_descriptor: false,
                ext_conditional_rendering: false,
                khr_shader_float16_int8: false,
                khr_16bit_storage: false,
                khr_incremental_present: false,
                khr_descriptor_update_template: false,
                nv_clip_space_w_scaling: false,
                ext_display_control: false,
                google_display_timing: false,
                nv_sample_mask_override_coverage: false,
                nv_geometry_shader_passthrough: false,
                nv_viewport_array2: false,
                nvx_multiview_per_view_attributes: false,
                nv_viewport_swizzle: false,
                ext_discard_rectangles: false,
                ext_conservative_rasterization: false,
                ext_depth_clip_enable: false,
                ext_hdr_metadata: false,
                khr_imageless_framebuffer: false,
                khr_create_renderpass2: false,
                khr_shared_presentable_image: false,
                khr_external_fence: false,
                khr_external_fence_win32: false,
                khr_external_fence_fd: false,
                khr_performance_query: false,
                khr_maintenance2: false,
                khr_variable_pointers: false,
                ext_external_memory_dma_buf: false,
                ext_queue_family_foreign: false,
                khr_dedicated_allocation: false,
                android_external_memory_android_hardware_buffer: false,
                ext_sampler_filter_minmax: false,
                khr_storage_buffer_storage_class: false,
                amd_gpu_shader_int16: false,
                amd_mixed_attachment_samples: false,
                amd_shader_fragment_mask: false,
                ext_inline_uniform_block: false,
                ext_shader_stencil_export: false,
                ext_sample_locations: false,
                khr_relaxed_block_layout: false,
                khr_get_memory_requirements2: false,
                khr_image_format_list: false,
                ext_blend_operation_advanced: false,
                nv_fragment_coverage_to_color: false,
                khr_acceleration_structure: false,
                khr_ray_tracing_pipeline: false,
                khr_ray_query: false,
                nv_framebuffer_mixed_samples: false,
                nv_fill_rectangle: false,
                nv_shader_sm_builtins: false,
                ext_post_depth_coverage: false,
                khr_sampler_ycbcr_conversion: false,
                khr_bind_memory2: false,
                ext_image_drm_format_modifier: false,
                ext_validation_cache: false,
                ext_descriptor_indexing: false,
                ext_shader_viewport_index_layer: false,
                khr_portability_subset: false,
                nv_shading_rate_image: false,
                nv_ray_tracing: false,
                nv_representative_fragment_test: false,
                khr_maintenance3: false,
                khr_draw_indirect_count: false,
                ext_filter_cubic: false,
                qcom_render_pass_shader_resolve: false,
                ext_global_priority: false,
                khr_shader_subgroup_extended_types: false,
                khr_8bit_storage: false,
                ext_external_memory_host: false,
                amd_buffer_marker: false,
                khr_shader_atomic_int64: false,
                khr_shader_clock: false,
                amd_pipeline_compiler_control: false,
                ext_calibrated_timestamps: false,
                amd_shader_core_properties: false,
                ext_video_decode_h265: false,
                khr_global_priority: false,
                amd_memory_overallocation_behavior: false,
                ext_vertex_attribute_divisor: false,
                ggp_frame_token: false,
                ext_pipeline_creation_feedback: false,
                khr_driver_properties: false,
                khr_shader_float_controls: false,
                nv_shader_subgroup_partitioned: false,
                khr_depth_stencil_resolve: false,
                khr_swapchain_mutable_format: false,
                nv_compute_shader_derivatives: false,
                nv_mesh_shader: false,
                nv_fragment_shader_barycentric: false,
                nv_shader_image_footprint: false,
                nv_scissor_exclusive: false,
                nv_device_diagnostic_checkpoints: false,
                khr_timeline_semaphore: false,
                intel_shader_integer_functions2: false,
                intel_performance_query: false,
                khr_vulkan_memory_model: false,
                ext_pci_bus_info: false,
                amd_display_native_hdr: false,
                khr_shader_terminate_invocation: false,
                ext_fragment_density_map: false,
                ext_scalar_block_layout: false,
                google_hlsl_functionality1: false,
                google_decorate_string: false,
                ext_subgroup_size_control: false,
                khr_fragment_shading_rate: false,
                amd_shader_core_properties2: false,
                amd_device_coherent_memory: false,
                ext_shader_image_atomic_int64: false,
                khr_spirv_1_4: false,
                ext_memory_budget: false,
                ext_memory_priority: false,
                nv_dedicated_allocation_image_aliasing: false,
                khr_separate_depth_stencil_layouts: false,
                ext_buffer_device_address: false,
                ext_tooling_info: false,
                ext_separate_stencil_usage: false,
                khr_present_wait: false,
                nv_cooperative_matrix: false,
                nv_coverage_reduction_mode: false,
                ext_fragment_shader_interlock: false,
                ext_ycbcr_image_arrays: false,
                khr_uniform_buffer_standard_layout: false,
                ext_provoking_vertex: false,
                ext_full_screen_exclusive: false,
                khr_buffer_device_address: false,
                ext_line_rasterization: false,
                ext_shader_atomic_float: false,
                ext_host_query_reset: false,
                ext_index_type_uint8: false,
                ext_extended_dynamic_state: false,
                khr_deferred_host_operations: false,
                khr_pipeline_executable_properties: false,
                ext_shader_atomic_float2: false,
                ext_shader_demote_to_helper_invocation: false,
                nv_device_generated_commands: false,
                nv_inherited_viewport_scissor: false,
                khr_shader_integer_dot_product: false,
                ext_texel_buffer_alignment: false,
                qcom_render_pass_transform: false,
                ext_device_memory_report: false,
                ext_robustness2: false,
                ext_custom_border_color: false,
                google_user_type: false,
                khr_pipeline_library: false,
                khr_shader_non_semantic_info: false,
                khr_present_id: false,
                ext_private_data: false,
                ext_pipeline_creation_cache_control: false,
                khr_video_encode_queue: false,
                nv_device_diagnostics_config: false,
                qcom_render_pass_store_ops: false,
                khr_synchronization2: false,
                khr_shader_subgroup_uniform_control_flow: false,
                khr_zero_initialize_workgroup_memory: false,
                nv_fragment_shading_rate_enums: false,
                nv_ray_tracing_motion_blur: false,
                ext_ycbcr_2plane_444_formats: false,
                ext_fragment_density_map2: false,
                qcom_rotated_copy_commands: false,
                ext_image_robustness: false,
                khr_workgroup_memory_explicit_layout: false,
                khr_copy_commands2: false,
                ext_4444_formats: false,
                arm_rasterization_order_attachment_access: false,
                ext_rgba10x6_formats: false,
                nv_acquire_winrt_display: false,
                valve_mutable_descriptor_type: false,
                ext_vertex_input_dynamic_state: false,
                ext_physical_device_drm: false,
                ext_depth_clip_control: false,
                ext_primitive_topology_list_restart: false,
                khr_format_feature_flags2: false,
                fuchsia_external_memory: false,
                fuchsia_external_semaphore: false,
                fuchsia_buffer_collection: false,
                huawei_subpass_shading: false,
                huawei_invocation_mask: false,
                nv_external_memory_rdma: false,
                ext_extended_dynamic_state2: false,
                ext_color_write_enable: false,
                ext_global_priority_query: false,
                ext_image_view_min_lod: false,
                ext_multi_draw: false,
                ext_load_store_op_none: false,
                ext_border_color_swizzle: false,
                ext_pageable_device_local_memory: false,
                khr_maintenance4: false,
                qcom_fragment_density_map_offset: false,
                nv_linear_color_attachment: false
            },
            Default::default()
        );
    }

    #[test]
    fn none() {
        assert_eq!(DeviceExtensions::default(), DeviceExtensions::none());
    }

    #[test]
    fn is_not_a_subset() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert!(!a.is_subset(&b));
    }

    #[test]
    fn is_subset() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert!(b.is_subset(&a));
    }

    #[test]
    fn is_not_a_superset() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert!(!b.is_superset(&a));
    }

    #[test]
    fn is_superset() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert!(a.is_superset(&b));
    }

    #[test]
    fn difference() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert_eq!(
            DeviceExtensions {
                ext_vertex_attribute_divisor: true,
                ..Default::default()
            },
            a.difference(&b)
        );
    }

    #[test]
    fn intersection() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ..Default::default()
        };
        assert_eq!(
            DeviceExtensions {
                khr_swapchain: true,
                ext_global_priority: true,
                ..Default::default()
            },
            a.intersection(&b)
        );
    }

    #[test]
    fn union() {
        let a = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            ext_vertex_attribute_divisor: true,
            ..Default::default()
        };
        let b = DeviceExtensions {
            khr_swapchain: true,
            ext_global_priority: true,
            amd_buffer_marker: true,
            ..Default::default()
        };
        assert_eq!(
            DeviceExtensions {
                khr_swapchain: true,
                ext_global_priority: true,
                ext_vertex_attribute_divisor: true,
                amd_buffer_marker: true,
                ..Default::default()
            },
            a.union(&b)
        );
    }
}
